"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/LocationMessage/Map.tsx
var Map_exports = {};
__export(Map_exports, {
  CustomMarker: () => CustomMarker,
  MapElement: () => MapElement,
  markerIcon: () => markerIcon
});
module.exports = __toCommonJS(Map_exports);
var import_react_leaflet = require("react-leaflet");
var import_leaflet = require("leaflet/dist/leaflet.css");
var import_leaflet2 = __toESM(require("leaflet"));
var import_jsx_runtime = require("react/jsx-runtime");
var markerIcon = import_leaflet2.default.icon({
  iconUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-icon.png",
  iconSize: [25, 41],
  iconAnchor: [12, 41],
  popupAnchor: [1, -34],
  shadowUrl: "https://unpkg.com/leaflet@1.9.3/dist/images/marker-shadow.png",
  shadowSize: [41, 41]
});
var CustomMarker = ({ position, children }) => {
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_leaflet.Marker, { position, icon: markerIcon, children });
};
var MapElement = (props) => {
  const { latitude, longitude, zoom } = props;
  function LocationMarker(props2) {
    if (!props2) {
      return null;
    }
    const { latLng, markerText, markerColor } = props2;
    return latLng ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_leaflet.Marker, { position: latLng, icon: markerIcon, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_react_leaflet.Popup, { children: markerText }) }) : null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    import_react_leaflet.MapContainer,
    {
      center: [latitude, longitude],
      zoom,
      scrollWheelZoom: false,
      children: [
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_react_leaflet.TileLayer,
          {
            attribution: '\xA9 <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
            url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
          }
        ),
        props.marker && /* @__PURE__ */ (0, import_jsx_runtime.jsx)(LocationMarker, __spreadValues({}, props.marker))
      ]
    }
  );
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CustomMarker,
  MapElement,
  markerIcon
});
