"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/MeetingItem/MeetingItem.tsx
var MeetingItem_exports = {};
__export(MeetingItem_exports, {
  default: () => MeetingItem_default,
  relativeDateFormat: () => relativeDateFormat
});
module.exports = __toCommonJS(MeetingItem_exports);
var import_md = require("react-icons/md");

// src/Avatar/Avatar.tsx
var import_classnames = __toESM(require("classnames"));
var import_jsx_runtime = require("react/jsx-runtime");
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var Avatar = (_a) => {
  var _b = _a, {
    size = "default",
    rounded = true
  } = _b, props = __objRest(_b, [
    "size",
    "rounded"
  ]);
  var _a2, _b2, _c;
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    "div",
    {
      className: (0, import_classnames.default)(
        "rce-avatar-container",
        size,
        props == null ? void 0 : props.className,
        rounded && "rounded"
      ),
      style: props == null ? void 0 : props.style,
      children: [
        props.letterItem || !(props == null ? void 0 : props.src) ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: "rce-avatar rce-avatar-letter-background",
            style: {
              backgroundColor: stringToColor(
                (_c = (_b2 = (_a2 = props.letterItem) == null ? void 0 : _a2.id) != null ? _b2 : props == null ? void 0 : props.title) != null ? _c : "unknown"
              )
            },
            children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
              "svg",
              {
                role: "img",
                xmlns: "http://www.w3.org/2000/svg",
                viewBox: "0 0 50 50",
                className: "rce-avatar-letter",
                children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
                  "text",
                  {
                    fill: "white",
                    fontSize: "25",
                    x: "50%",
                    y: "50%",
                    dominantBaseline: "central",
                    textAnchor: "middle",
                    children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
                  }
                )
              }
            )
          }
        ) : /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "img",
          {
            loading: "lazy",
            alt: props == null ? void 0 : props.alt,
            src: props == null ? void 0 : props.src,
            onError: props == null ? void 0 : props.onError,
            className: "rce-avatar"
          }
        ),
        props == null ? void 0 : props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

// src/MeetingItem/MeetingItem.tsx
var import_date_fns = require("date-fns");
var import_classnames2 = __toESM(require("classnames"));
var import_react = require("react");
var import_jsx_runtime2 = require("react/jsx-runtime");
var relativeDateFormat = (date = /* @__PURE__ */ new Date()) => {
  let dateObject;
  try {
    if (date instanceof Date) {
      dateObject = date;
    } else {
      dateObject = new Date(date);
    }
  } catch (error) {
    dateObject = /* @__PURE__ */ new Date();
    console.error("the date provided is not valid", error);
  }
  return (0, import_date_fns.formatDistance)(dateObject, /* @__PURE__ */ new Date(), {
    addSuffix: true
  }).replace("less than a minute ago", "now");
};
var MeetingItem = (props) => {
  var _a, _b;
  const [attributes, setAttributes] = (0, import_react.useState)(__spreadValues({
    subjectLimit: 60,
    avatarFlexible: false,
    date: /* @__PURE__ */ new Date(),
    avatarLimit: 5,
    avatars: [],
    audioMuted: true,
    dateString: (_a = props.dateString) != null ? _a : relativeDateFormat(props.date)
  }, props));
  const subject = attributes.subject && attributes.subjectLimit && attributes.subject.substring(0, attributes.subjectLimit) + (attributes.subject.length > attributes.subjectLimit ? "..." : "");
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: (0, import_classnames2.default)("rce-container-mtitem", attributes.className), children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      "audio",
      {
        autoPlay: true,
        loop: true,
        muted: attributes.audioMuted,
        src: attributes.audioSource
      }
    ),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem", children: [
      /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-top", children: [
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mtitem-subject", children: subject }),
        /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: "rce-mtitem-share",
            onClick: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            onKeyDown: (event) => {
              var _a2;
              return (_a2 = attributes == null ? void 0 : attributes.onShare) == null ? void 0 : _a2.call(attributes, event, attributes, setAttributes);
            },
            children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdLink, {})
          }
        )
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body", children: [
        /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body--avatars", children: [
          (_b = attributes.avatars) == null ? void 0 : _b.slice(0, attributes.avatarLimit).map((x, i) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            Avatar_default,
            {
              title: x.title,
              src: x.src,
              alt: x.alt,
              className: x.statusColorType === "encircle" ? "rce-mtitem-avatar-encircle-status" : "",
              size: "small",
              letterItem: x.letterItem,
              sideElement: x.statusColor ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "span",
                {
                  className: "rce-mtitem-status",
                  style: x.statusColorType === "encircle" ? {
                    boxShadow: `inset 0 0 0 2px ${x.statusColor}, inset 0 0 0 5px #FFFFFF`
                  } : {
                    backgroundColor: x.statusColor
                  },
                  children: x.statusText
                }
              ) : null,
              onError: attributes.onAvatarError,
              type: (0, import_classnames2.default)("circle", {
                flexible: attributes.avatarFlexible
              })
            },
            i.toString()
          )),
          attributes.avatars && attributes.avatarLimit && attributes.avatars.length > attributes.avatarLimit && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-avatar-container circle small rce-mtitem-letter", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { children: `+${attributes.avatars.length - attributes.avatarLimit}` }) })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("div", { className: "rce-mtitem-body--functions", children: [
          attributes.closable && /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "div",
            {
              className: "rce-mtitem-closable",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onClose) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdCall, {})
            }
          ),
          /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
            "div",
            {
              className: "rce-mtitem-button",
              onClick: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              onKeyDown: (ev) => {
                var _a2;
                return (_a2 = attributes.onMeeting) == null ? void 0 : _a2.call(attributes, ev, attributes, setAttributes);
              },
              children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_md.MdVideoCall, {})
            }
          )
        ] })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className: "rce-mtitem-footer", children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("span", { className: "rce-mtitem-date", children: attributes.dateString }) })
    ] })
  ] });
};
var MeetingItem_default = MeetingItem;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  relativeDateFormat
});
