import {
  relativeDateFormat
} from "./chunk-C5CDOU3O.mjs";
import {
  Badge_default
} from "./chunk-IK3UXS7Y.mjs";
import {
  Avatar_default
} from "./chunk-BJWYLI76.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/ChatItem/ChatItem.tsx
import classNames from "classnames";
import { MdVideoCall, MdVolumeOff, MdVolumeUp } from "react-icons/md";
import { FaArrowDown, FaArrowUp } from "react-icons/fa";
import { cloneElement, useState } from "react";
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { createElement } from "react";
var ChatItem = (_a) => {
  var _b = _a, {
    avatarFlexible = false,
    date = /* @__PURE__ */ new Date(),
    statusColor,
    showVideoCall = false,
    showMute = false,
    avatar = void 0
  } = _b, rest = __objRest(_b, [
    "avatarFlexible",
    "date",
    "statusColor",
    "showVideoCall",
    "showMute",
    "avatar"
  ]);
  var _a2, _b2, _c, _d;
  const [isExpanded, setIsExpanded] = useState(rest.expanded || false);
  const [attributes, setAttributes] = useState(rest);
  function getStatusItem() {
    if ((attributes == null ? void 0 : attributes.statusColorType) === "badge") {
      return /* @__PURE__ */ jsx(
        Badge_default,
        {
          backgroundColor: statusColor,
          value: attributes == null ? void 0 : attributes.statusText,
          position: "top-right"
        }
      );
    }
    if ((attributes == null ? void 0 : attributes.statusColorType) === "encircle") {
      return /* @__PURE__ */ jsx(
        "span",
        {
          className: "rce-citem-status encircle",
          style: { borderColor: statusColor != null ? statusColor : "var(--rce-color-green)" }
        }
      );
    }
    return null;
  }
  return /* @__PURE__ */ jsx(
    "div",
    {
      className: classNames("rce-container-citem", attributes.className),
      onClick: (ev) => {
        var _a3;
        return (_a3 = attributes == null ? void 0 : attributes.onClick) == null ? void 0 : _a3.call(attributes, ev, attributes, setAttributes);
      },
      onContextMenu: (ev) => {
        var _a3;
        return (_a3 = attributes == null ? void 0 : attributes.onContextMenu) == null ? void 0 : _a3.call(attributes, ev, attributes, setAttributes);
      },
      onKeyDown: (ev) => {
        var _a3;
        return (_a3 = attributes == null ? void 0 : attributes.onKeyDown) == null ? void 0 : _a3.call(attributes, ev, attributes, setAttributes);
      },
      children: /* @__PURE__ */ jsxs("div", { className: "rce-citem", children: [
        /* @__PURE__ */ jsxs(
          "div",
          {
            className: classNames("rce-citem-avatar", {
              "rce-citem-status-encircle": (attributes == null ? void 0 : attributes.statusColorType) === "encircle"
            }),
            children: [
              /* @__PURE__ */ jsx(
                Avatar_default,
                {
                  src: avatar,
                  alt: attributes.alt,
                  title: attributes.title,
                  className: (attributes == null ? void 0 : attributes.statusColorType) === "encircle" ? "rce-citem-avatar-encircle-status" : void 0,
                  size: attributes.avatarSize || "default",
                  letterItem: attributes.letterItem,
                  sideElement: getStatusItem(),
                  onError: attributes.onAvatarError,
                  type: classNames("circle", { flexible: avatarFlexible })
                }
              ),
              ((_a2 = attributes == null ? void 0 : attributes.subList) == null ? void 0 : _a2.length) && /* @__PURE__ */ jsxs(Fragment, { children: [
                /* @__PURE__ */ jsx(
                  "button",
                  {
                    type: "button",
                    className: "rce-citem-expand-button",
                    onClick: () => setIsExpanded(!isExpanded),
                    children: attributes.expanded ? /* @__PURE__ */ jsx(FaArrowUp, {}) : /* @__PURE__ */ jsx(FaArrowDown, {})
                  }
                ),
                /* @__PURE__ */ jsx(
                  "div",
                  {
                    className: "mce-citem-sublist",
                    style: { display: attributes.expanded ? "block" : "none" },
                    children: (_b2 = attributes.subList) == null ? void 0 : _b2.map((sub, i) => /* @__PURE__ */ createElement(
                      ChatItem,
                      __spreadProps(__spreadValues({}, sub), {
                        className: "subitem",
                        avatarSize: "xsmall",
                        key: `subitem-${i.toString()}`
                      })
                    ))
                  }
                )
              ] })
            ]
          }
        ),
        /* @__PURE__ */ jsxs("div", { className: "rce-citem-body", children: [
          /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--top", children: [
            /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-title", children: attributes.title }),
            /* @__PURE__ */ jsx("div", { className: "rce-citem-body--top-time", children: date && (attributes.dateString || relativeDateFormat(date)) })
          ] }),
          /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--bottom", children: [
            /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-title", children: attributes.subtitle }),
            /* @__PURE__ */ jsxs("div", { className: "rce-citem-body--bottom-elements", children: [
              /* @__PURE__ */ jsxs(
                "div",
                {
                  className: "rce-citem-body--bottom-tools",
                  onMouseEnter: attributes == null ? void 0 : attributes.handleOnMouseEnter,
                  onMouseLeave: attributes == null ? void 0 : attributes.handleOnMouseLeave,
                  children: [
                    showMute ? /* @__PURE__ */ jsx(
                      Button_default,
                      {
                        link: true,
                        className: "rce-citem-body--bottom-tools-item",
                        onClick: (ev) => {
                          var _a3;
                          return (_a3 = attributes == null ? void 0 : attributes.onMuteToggle) == null ? void 0 : _a3.call(attributes, ev, attributes, setAttributes);
                        },
                        icon: {
                          component: (attributes == null ? void 0 : attributes.muted) ? /* @__PURE__ */ jsx(MdVolumeOff, {}) : /* @__PURE__ */ jsx(MdVolumeUp, {})
                        }
                      }
                    ) : null,
                    "showVideoCall" in attributes ? /* @__PURE__ */ jsx(
                      Button_default,
                      {
                        link: true,
                        className: "rce-citem-body--bottom-tools-item",
                        onClick: (ev) => {
                          var _a3;
                          return (_a3 = attributes == null ? void 0 : attributes.onVideoCall) == null ? void 0 : _a3.call(attributes, ev, attributes, setAttributes);
                        },
                        icon: { component: /* @__PURE__ */ jsx(MdVideoCall, {}) }
                      }
                    ) : null
                  ]
                }
              ),
              /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-tools-item-hidden-hover", children: showMute && (attributes == null ? void 0 : attributes.muted) && /* @__PURE__ */ jsx("div", { className: "rce-citem-body--bottom-tools-item", children: /* @__PURE__ */ jsx(MdVolumeOff, {}) }) }),
              (attributes == null ? void 0 : attributes.unread) ? /* @__PURE__ */ jsx(
                Badge_default,
                {
                  className: "rce-citem-body--bottom-status",
                  value: attributes.unread
                }
              ) : null,
              (_d = (_c = attributes == null ? void 0 : attributes.customStatusComponents) == null ? void 0 : _c.map(
                (el, index) => {
                  return cloneElement(el, { key: index.toString() });
                }
              )) != null ? _d : null
            ] })
          ] })
        ] }, "rce-citem-body")
      ] })
    }
  );
};
var ChatItem_default = ChatItem;

export {
  ChatItem_default
};
