import {
  getAvatar,
  getRandomColor,
  getRandomImage,
  getRandomInRange,
  getRandomStatus,
  photo,
  require_dist,
  token
} from "./chunk-EV7AFHZX.mjs";
import {
  __spreadProps,
  __spreadValues,
  __toESM
} from "./chunk-YUVL7GHC.mjs";

// src/stories/utils/MessageTypes.ts
var import_lorem_ipsum = __toESM(require_dist());
import { MdOutlineVideoCall } from "react-icons/md";
var messageDefaultdata = () => ({
  id: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" }),
  position: token(2) > 1 ? "right" : "left",
  date: +/* @__PURE__ */ new Date(),
  type: "text",
  //date
  dateString: void 0,
  forwarded: false,
  forwardedMessageText: "Forwarded",
  // props
  notch: true,
  focus: false,
  replyButton: true,
  removeButton: true,
  emojiButton: true,
  retracted: false,
  copiableDate: true,
  // content
  text: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "sentences" }),
  title: (0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" }),
  titleColor: getRandomColor(),
  // status
  status: getRandomStatus(),
  statusTitle: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" })
});
var avatar = {
  avatar: photo(),
  avatarFlexible: true
};
var reply = token() >= 1 ? {
  photoURL: token() >= 1 ? getAvatar() : void 0,
  title: (0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" }),
  titleColor: getRandomColor(),
  text: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "sentences" })
} : void 0;
var photoMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "photo",
  data: {
    uri: getRandomImage(),
    status: {
      click: (e) => console.log("click", e),
      download: (e) => console.log("download", e),
      loading: false,
      error: false
    },
    width: 300,
    height: 300
  }
});
var locationMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "location",
  avatar: getAvatar(),
  latitude: Number(getRandomInRange(-90, 90, 5)),
  longitude: Number(getRandomInRange(-180, 180, 5)),
  zoom: 5,
  marker: {
    latLng: {
      lat: Number(getRandomInRange(-90, 90, 5)),
      lng: Number(getRandomInRange(-180, 180, 5))
    },
    markerColor: "red",
    markerText: ""
  }
});
var fileMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "file",
  data: {
    status: {
      loading: true,
      error: false,
      click: (e) => console.log(e),
      download: (e) => console.log(e)
    },
    size: `${token(100)}MB`,
    extension: "pdf",
    name: `${(0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" })}.pdf`
  }
});
var messageWithReply = () => __spreadProps(__spreadValues(__spreadValues({}, avatar), messageDefaultdata()), {
  type: "text",
  reply
});
var systemMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "system"
});
var videoMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "video",
  controlsList: "",
  data: {
    uri: getAvatar(`avatar${token()}`),
    videoURL: token() >= 1 ? "https://www.w3schools.com/html/mov_bbb.mp4" : "http://www.exit109.com/~dnn/clips/RW20seconds_1.mp4",
    status: {
      click: (e) => {
        console.log(e, "click");
      },
      loading: true,
      download: (e) => {
        console.log(e, "download");
      },
      error: false
    },
    width: 400,
    height: 250
  }
});
var audioMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "audio",
  data: {
    audioURL: "https://www.w3schools.com/html/horse.mp3",
    audioType: "audio/mp3",
    controlsList: "nodownload"
  }
});
var meetingMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "meeting",
  subject: (0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" }),
  collapseTitle: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" }),
  participants: Array(token(6)).fill(1).map((x) => ({
    id: token(3),
    title: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" })
  })),
  actionButtons: [
    {
      onClickButton(id) {
        console.log(id);
      },
      Component: () => MdOutlineVideoCall({ size: "25px" })
    },
    {
      onClickButton(id) {
        console.log(id);
      },
      Component: () => MdOutlineVideoCall({ size: "25px" })
    }
  ],
  dataSource: Array(token(5)).fill(1).map((x) => __spreadProps(__spreadValues({}, messageDefaultdata()), {
    type: "meeting",
    date: +/* @__PURE__ */ new Date(),
    event: {
      title: (0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" }),
      avatars: Array(token(2)).fill(1).map((x2) => ({
        src: getAvatar(`avatar${token()}`),
        title: "react, rce"
      })),
      avatarsLimit: 5
    },
    record: {
      cover: getRandomImage(),
      title: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" }),
      savedBy: `Saved by: ${(0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" })}`,
      time: (/* @__PURE__ */ new Date()).toLocaleString()
    }
  }))
});
var meetingLinkMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  type: "meetingLink",
  actionButtons: [
    {
      onClickButton(id) {
        console.log(id);
      },
      Component: () => MdOutlineVideoCall({ size: "25px" })
    },
    {
      onClickButton(id) {
        console.log(id);
      },
      Component: () => MdOutlineVideoCall({ size: "25px" })
    }
  ],
  meetingID: String(Math.round(Math.random() * 10))
});
var textMessage = () => __spreadProps(__spreadValues({}, messageDefaultdata()), {
  avatar: getAvatar(`avatar${token()}`),
  type: "text"
});
var chatListArray = (i = 0) => {
  const name = (0, import_lorem_ipsum.loremIpsum)({ count: 2, units: "words" });
  return {
    id: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "words" }) + i,
    avatar: getAvatar(name),
    statusColor: token(2) === 1 ? void 0 : getRandomColor(),
    statusColorType: [void 0, "encircle", "badge"][token(3)],
    alt: name,
    title: name,
    date: /* @__PURE__ */ new Date(),
    subtitle: (0, import_lorem_ipsum.loremIpsum)({ count: 1, units: "sentences" }),
    unread: Math.floor(Math.random() * 10 % 3),
    muted: Math.floor(Math.random() * 10 % 2) === 1,
    showMute: Math.floor(Math.random() * 10 % 2) === 1,
    showVideoCall: Math.floor(Math.random() * 10 % 2) === 1
  };
};

export {
  messageDefaultdata,
  avatar,
  reply,
  photoMessage,
  locationMessage,
  fileMessage,
  messageWithReply,
  systemMessage,
  videoMessage,
  audioMessage,
  meetingMessage,
  meetingLinkMessage,
  textMessage,
  chatListArray
};
