import {
  MapElement
} from "./chunk-2ZVH2M5D.mjs";
import {
  STATIC_URL
} from "./chunk-VZ4NQKVS.mjs";
import {
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/LocationMessage/LocationMessage.tsx
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var LocationMessage = (props) => {
  var _a;
  const { latitude = 0, longitude = 0, zoom = 5 } = props;
  const buildURL = (url) => {
    return url.replace(/LATITUDE/g, latitude.toString()).replace(/LONGITUDE/g, longitude.toString()).replace("ZOOM", zoom.toString());
  };
  const className = () => {
    let _className = classNames("rce-mbox-location", props.className);
    if (props.text) {
      _className = classNames(_className, "rce-mbox-location-has-text");
    }
    return _className;
  };
  return /* @__PURE__ */ jsxs("div", { className: "rce-container-lmsg", children: [
    /* @__PURE__ */ jsx(
      "a",
      {
        onClick: props.onOpen,
        target: (_a = props.target) != null ? _a : "_blank",
        href: props.href || props.src || buildURL((props == null ? void 0 : props.mapURL) || STATIC_URL),
        className: className(),
        children: /* @__PURE__ */ jsx(
          MapElement,
          __spreadValues({
            onError: props.onError,
            className: "rce-mbox-location-img h-full w-full"
          }, props)
        )
      }
    ),
    props.text && /* @__PURE__ */ jsx("div", { className: "rce-mbox-text rce-mbox-location-text", children: props.text })
  ] });
};
var LocationMessage_default = LocationMessage;

export {
  LocationMessage_default
};
