import {
  __objRest
} from "./chunk-YUVL7GHC.mjs";

// src/Avatar/Avatar.tsx
import classNames from "classnames";
import { jsx, jsxs } from "react/jsx-runtime";
var stringToColor = (str) => {
  let hash = 0;
  for (let i = 0; i < str.length; i++) {
    hash = str.charCodeAt(i) + ((hash << 5) - hash);
  }
  let colour = "#";
  for (let i = 0; i < 3; i++) {
    let value = hash >> i * 8 & 255;
    value = value % 150 + 50;
    colour += `00${value.toString(16)}`.substr(-2);
  }
  return colour;
};
function getAvatarLetters(letterItem, title) {
  let name = "U";
  if (letterItem == null ? void 0 : letterItem.letter) {
    name = letterItem.letter;
  }
  if (title) {
    name = title;
  }
  return name.toUpperCase().split(" ").map((w) => w[0]).slice(0, 2).join("");
}
var Avatar = (_a) => {
  var _b = _a, {
    size = "default",
    rounded = true
  } = _b, props = __objRest(_b, [
    "size",
    "rounded"
  ]);
  var _a2, _b2, _c;
  return /* @__PURE__ */ jsxs(
    "div",
    {
      className: classNames(
        "rce-avatar-container",
        size,
        props == null ? void 0 : props.className,
        rounded && "rounded"
      ),
      style: props == null ? void 0 : props.style,
      children: [
        props.letterItem || !(props == null ? void 0 : props.src) ? /* @__PURE__ */ jsx(
          "div",
          {
            className: "rce-avatar rce-avatar-letter-background",
            style: {
              backgroundColor: stringToColor(
                (_c = (_b2 = (_a2 = props.letterItem) == null ? void 0 : _a2.id) != null ? _b2 : props == null ? void 0 : props.title) != null ? _c : "unknown"
              )
            },
            children: /* @__PURE__ */ jsx(
              "svg",
              {
                role: "img",
                xmlns: "http://www.w3.org/2000/svg",
                viewBox: "0 0 50 50",
                className: "rce-avatar-letter",
                children: /* @__PURE__ */ jsx(
                  "text",
                  {
                    fill: "white",
                    fontSize: "25",
                    x: "50%",
                    y: "50%",
                    dominantBaseline: "central",
                    textAnchor: "middle",
                    children: getAvatarLetters(props == null ? void 0 : props.letterItem, props == null ? void 0 : props.title)
                  }
                )
              }
            )
          }
        ) : /* @__PURE__ */ jsx(
          "img",
          {
            loading: "lazy",
            alt: props == null ? void 0 : props.alt,
            src: props == null ? void 0 : props.src,
            onError: props == null ? void 0 : props.onError,
            className: "rce-avatar"
          }
        ),
        props == null ? void 0 : props.sideElement
      ]
    }
  );
};
var Avatar_default = Avatar;

export {
  stringToColor,
  Avatar_default
};
