import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/Input/Input.tsx
import { useEffect, useState } from "react";
import classNames from "classnames";
import { MdClear } from "react-icons/md";
import { jsx, jsxs } from "react/jsx-runtime";
var Input = (props) => {
  var _b, _c;
  const _a = props, {
    type = "text",
    multiline = false,
    minHeight = 25,
    maxHeight = 200,
    autoHeight = true,
    autofocus = false,
    clearButton = true,
    placeholder = "Type here...",
    maxlength = 200,
    onMaxLengthExceed = () => console.warn("The maxlength has been exceeded"),
    value: propValue = "",
    style = {}
  } = _a, rest = __objRest(_a, [
    "type",
    "multiline",
    "minHeight",
    "maxHeight",
    "autoHeight",
    "autofocus",
    "clearButton",
    "placeholder",
    "maxlength",
    "onMaxLengthExceed",
    "value",
    "style"
  ]);
  const [value, setValue] = useState(
    propValue || rest.defaultValue || ""
  );
  useEffect(() => {
    var _a2, _b2;
    if (autofocus) (_b2 = (_a2 = rest.reference) == null ? void 0 : _a2.current) == null ? void 0 : _b2.focus();
  }, [autofocus, (_c = (_b = rest.reference) == null ? void 0 : _b.current) == null ? void 0 : _c.focus]);
  useEffect(() => {
    setValue(propValue);
  }, [propValue]);
  const onSubmitEvent = (ev) => {
    ev.preventDefault();
    setValue("");
    if (rest.onSubmit instanceof Function) rest.onSubmit(ev);
  };
  const onChangeEvent = (ev) => {
    var _a2;
    const el = ev.target;
    let newValue = el.value;
    if (newValue) {
      setValue(newValue);
    }
    if (multiline) {
      if (autoHeight) {
        if (style.height !== `${minHeight}px`) {
          style.height = `${minHeight}px`;
        }
        let height = "";
        if (el.scrollHeight <= maxHeight) height = `${el.scrollHeight}px`;
        else height = `${maxHeight}px`;
        if (style.height !== height) {
          style.height = height;
        }
      }
    }
    if (maxlength && (el.value || "").length > maxlength) {
      if (onMaxLengthExceed instanceof Function) onMaxLengthExceed();
      if ((_a2 = rest.reference) == null ? void 0 : _a2.current) {
        newValue = newValue.substring(0, maxlength);
        rest.reference.current.value = newValue;
        setValue(newValue);
      }
      return;
    }
  };
  const clear = () => {
    var _a2;
    if ((_a2 = rest.reference) == null ? void 0 : _a2.current) {
      rest.reference.current.value = "";
    }
    setValue("");
  };
  return /* @__PURE__ */ jsxs(
    "form",
    {
      onSubmit: onSubmitEvent,
      className: classNames("rce-container-input", rest.className),
      style,
      children: [
        rest.leftButtons && /* @__PURE__ */ jsx("div", { className: "rce-input-buttons", children: rest.leftButtons }),
        /* @__PURE__ */ jsxs("div", { className: "rce-input-content w-full relative", children: [
          !multiline ? /* @__PURE__ */ jsx(
            "input",
            __spreadProps(__spreadValues({}, rest), {
              name: "chat-input",
              style: rest.inputStyle,
              ref: rest.reference,
              type,
              className: "rce-input w-full",
              placeholder,
              value,
              onChange: (e) => onChangeEvent(e)
            })
          ) : /* @__PURE__ */ jsx(
            "textarea",
            __spreadProps(__spreadValues({}, rest), {
              ref: rest.reference,
              className: classNames("rce-input", "rce-input-textarea"),
              placeholder,
              style: rest.inputStyle,
              onChange: (e) => onChangeEvent(e),
              children: value
            })
          ),
          clearButton && value && /* @__PURE__ */ jsx(
            Button_default,
            {
              className: "rce-input-clear",
              onClick: clear,
              backgroundColor: "transparent",
              style: {
                position: "absolute",
                zIndex: 1,
                right: 0,
                top: 0,
                opacity: 0.3
              },
              icon: {
                component: /* @__PURE__ */ jsx(MdClear, { color: "var(--rce-color-gray)", size: 20 })
              }
            }
          )
        ] }),
        rest.rightButtons && /* @__PURE__ */ jsx("div", { className: "rce-input-buttons", children: rest.rightButtons })
      ]
    }
  );
};
var Input_default = Input;

export {
  Input_default
};
