import {
  LeftNotch
} from "./chunk-PUN464RA.mjs";
import {
  RightNotch
} from "./chunk-BMQ5JV2I.mjs";
import {
  SystemMessage_default
} from "./chunk-A73P7STW.mjs";
import {
  VideoMessage_default
} from "./chunk-A4BIL7XO.mjs";
import {
  PhotoMessage_default
} from "./chunk-SLZWSA5J.mjs";
import {
  ReplyMessage_default
} from "./chunk-6MSRT2AT.mjs";
import {
  MeetingLink_default
} from "./chunk-VFG4DATW.mjs";
import {
  MeetingMessage_default
} from "./chunk-D2UVGANW.mjs";
import {
  relativeDateFormat
} from "./chunk-C5CDOU3O.mjs";
import {
  FileMessage_default
} from "./chunk-RJTUV4QC.mjs";
import {
  LocationMessage_default
} from "./chunk-ASCZ3WY2.mjs";
import {
  AudioMessage_default
} from "./chunk-A6WEVOZG.mjs";
import {
  Avatar_default
} from "./chunk-BJWYLI76.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/MessageBox/MessageBox.tsx
import { useEffect, useRef, useState } from "react";
import classNames from "classnames";
import {
  MdAccessTime,
  MdCheck,
  MdDelete,
  MdDoneAll,
  MdReply,
  MdReplyAll,
  MdEdit,
  MdOutlineEmojiEmotions
} from "react-icons/md";
import { format } from "date-fns";
import { jsx, jsxs } from "react/jsx-runtime";
var MessageBox = (props) => {
  const [attributes, setAttributes] = useState(__spreadValues({
    style: {},
    actionButtons: void 0,
    forwardedMessageText: "Forwarded",
    notch: true
  }, props));
  const prevProps = useRef(attributes.focus);
  const messageRef = useRef(null);
  const positionCls = classNames("rce-mbox", {
    "rce-mbox-right": attributes.position === "right",
    "rce-mbox-left": attributes.position !== "right"
  });
  const defaultActionStyle = {
    color: "var(--rce-color-white)",
    backgroundColor: "rgba(110, 110, 120, .5)",
    style: {
      padding: "6px",
      borderWidth: 0
    }
  };
  const thatAbsoluteTime = !/(text|video|file|meeting|audio)/g.test(attributes.type || "text") && !(attributes.type === "location" && attributes.text);
  const dateText = attributes.date && (attributes.dateString || format(attributes.date, "HH:mm"));
  useEffect(() => {
    var _a;
    if (prevProps.current !== attributes.focus && attributes.focus) {
      if (messageRef == null ? void 0 : messageRef.current) {
        (_a = messageRef.current) == null ? void 0 : _a.scrollIntoView({
          behavior: "smooth",
          block: "nearest",
          inline: "start"
        });
        if (attributes.onMessageFocused instanceof Function)
          attributes.onMessageFocused(true);
      }
    }
    prevProps.current = attributes.focus;
  }, [attributes.focus, attributes.onMessageFocused]);
  return /* @__PURE__ */ jsxs(
    "div",
    {
      ref: messageRef,
      className: classNames("rce-container-mbox", attributes.className),
      children: [
        attributes == null ? void 0 : attributes.renderAddCmp,
        attributes.type === "system" ? /* @__PURE__ */ jsx(SystemMessage_default, __spreadValues({}, attributes)) : /* @__PURE__ */ jsxs(
          "div",
          {
            className: classNames(
              positionCls,
              { "rce-mbox--clear-padding": thatAbsoluteTime },
              { "rce-mbox--clear-notch": !attributes.notch }
            ),
            children: [
              attributes.notch && (attributes.position === "right" ? /* @__PURE__ */ jsx(
                RightNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background-right)"
                  }, attributes.notchStyle),
                  focus: attributes.focus
                }
              ) : /* @__PURE__ */ jsx(
                LeftNotch,
                {
                  style: __spreadValues({
                    fill: "var(--rce-mbox-background)"
                  }, attributes.notchStyle),
                  focus: attributes.focus
                }
              )),
              /* @__PURE__ */ jsxs(
                "div",
                {
                  className: classNames("rce-mbox-body", {
                    "message-focus": attributes.focus
                  }),
                  onContextMenu: attributes == null ? void 0 : attributes.onContextMenu,
                  style: attributes.style,
                  children: [
                    /* @__PURE__ */ jsxs("div", { className: "rce-mbox-action-buttons", children: [
                      !attributes.retracted && attributes.EmojiButton === true && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: classNames(
                            "rce-mbox-action",
                            "rce-mbox-emoji-button",
                            {
                              "rce-mbox-forward-right": attributes.position === "left"
                            },
                            {
                              "rce-mbox-forward-left": attributes.position === "right"
                            }
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = attributes == null ? void 0 : attributes.AddEmoji) == null ? void 0 : _a.call(attributes, e, attributes, setAttributes);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(MdOutlineEmojiEmotions, { size: 20 })
                          }
                        }, defaultActionStyle)
                      ),
                      !attributes.retracted && !attributes.forwarded && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            {
                              "rce-mbox-forward-right": attributes.position === "left"
                            },
                            {
                              "rce-mbox-forward-left": attributes.position === "right"
                            }
                          ),
                          onClick: (e) => {
                            var _a;
                            return (_a = attributes.onForward) == null ? void 0 : _a.call(attributes, e, attributes, setAttributes);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(
                              MdReplyAll,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !attributes.retracted && attributes.replyButton && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: !attributes.forwarded ? classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-forward-${attributes.position}`
                          ) : classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${attributes.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = attributes.onReplyMessage) == null ? void 0 : _a.call(attributes, ev, attributes, setAttributes);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(
                              MdReply,
                              {
                                size: 20,
                                className: "reverse-icon-horizontal"
                              }
                            )
                          }
                        }, defaultActionStyle)
                      ),
                      !attributes.retracted && attributes.removeButton && /* @__PURE__ */ jsx(
                        Button_default,
                        __spreadValues({
                          circle: true,
                          className: attributes.forwarded ? classNames(
                            "rce-mbox-action",
                            "rce-mbox-remove",
                            `rce-mbox-remove-${attributes.position}`
                          ) : classNames(
                            "rce-mbox-action",
                            "rce-mbox-forward",
                            `rce-mbox-reply-btn-${attributes.position}`
                          ),
                          onClick: (ev) => {
                            var _a;
                            return (_a = attributes.onRemoveMessage) == null ? void 0 : _a.call(attributes, ev, attributes, setAttributes);
                          },
                          icon: {
                            component: /* @__PURE__ */ jsx(MdDelete, { size: 20 })
                          }
                        }, defaultActionStyle)
                      )
                    ] }),
                    (attributes.title || attributes.avatar) && /* @__PURE__ */ jsxs(
                      "div",
                      {
                        style: __spreadValues({}, attributes.titleColor && {
                          color: attributes.titleColor
                        }),
                        onClick: (event) => {
                          var _a;
                          return (_a = attributes.onTitleClick) == null ? void 0 : _a.call(attributes, event, attributes, setAttributes);
                        },
                        onKeyDown: (event) => {
                          var _a;
                          return (_a = attributes.onTitleClick) == null ? void 0 : _a.call(attributes, event, attributes, setAttributes);
                        },
                        className: classNames("rce-mbox-title", {
                          "rce-mbox-title--clear": attributes.type === "text"
                        }),
                        children: [
                          attributes.avatar && /* @__PURE__ */ jsx(
                            Avatar_default,
                            {
                              title: attributes.title || "Unknown",
                              size: "xsmall",
                              letterItem: attributes.letterItem,
                              src: attributes.avatar
                            }
                          ),
                          attributes.title && /* @__PURE__ */ jsx("span", { children: attributes.title })
                        ]
                      }
                    ),
                    attributes.reply ? /* @__PURE__ */ jsx(
                      ReplyMessage_default,
                      __spreadValues({
                        onClick: (e) => {
                          var _a;
                          return (_a = attributes.onReplyMessage) == null ? void 0 : _a.call(attributes, e, attributes, setAttributes);
                        }
                      }, attributes.reply)
                    ) : null,
                    attributes.forwarded ? /* @__PURE__ */ jsx("div", { className: "rce-mbox-forwarded-message", children: /* @__PURE__ */ jsxs("div", { className: "rce-mbox-forwarded-message-inner", children: [
                      /* @__PURE__ */ jsx(
                        MdReply,
                        {
                          size: 15,
                          style: { padding: 0 },
                          className: "reverse-icon-horizontal"
                        }
                      ),
                      /* @__PURE__ */ jsx("i", { children: attributes.forwardedMessageText })
                    ] }) }) : null,
                    attributes.type === "text" && /* @__PURE__ */ jsxs(
                      "div",
                      {
                        className: classNames(
                          "rce-mbox-text",
                          (attributes == null ? void 0 : attributes.position) === "right" ? "right" : "left",
                          {
                            "rce-mbox-text-retracted": attributes.retracted
                          }
                        ),
                        children: [
                          !attributes.forwarded && attributes.retracted && /* @__PURE__ */ jsx(MdEdit, {}),
                          attributes.text
                        ]
                      }
                    ),
                    attributes.type === "location" && /* @__PURE__ */ jsx(LocationMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "photo" && /* @__PURE__ */ jsx(PhotoMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "video" && /* @__PURE__ */ jsx(VideoMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "file" && /* @__PURE__ */ jsx(FileMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "meeting" && /* @__PURE__ */ jsx(MeetingMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "audio" && /* @__PURE__ */ jsx(AudioMessage_default, __spreadValues({}, attributes)),
                    attributes.type === "meetingLink" && /* @__PURE__ */ jsx(
                      MeetingLink_default,
                      __spreadProps(__spreadValues({}, attributes), {
                        actionButtons: props.actionButtons
                      })
                    ),
                    /* @__PURE__ */ jsxs(
                      "div",
                      {
                        title: attributes.statusTitle,
                        className: classNames(
                          "rce-mbox-time",
                          { "rce-mbox-time-block": thatAbsoluteTime },
                          { "non-copiable": !attributes.copiableDate }
                        ),
                        "data-text": attributes.copiableDate ? void 0 : dateText,
                        children: [
                          attributes.copiableDate && attributes.date !== void 0 && relativeDateFormat(attributes.date),
                          attributes.status && /* @__PURE__ */ jsxs("span", { className: "rce-mbox-status", children: [
                            attributes.status === "waiting" && /* @__PURE__ */ jsx(
                              MdAccessTime,
                              {
                                color: "var(--rce-color-gray)",
                                style: { fontSize: 18 }
                              }
                            ),
                            attributes.status === "sent" && /* @__PURE__ */ jsx(
                              MdCheck,
                              {
                                color: "var(--rce-color-light-blue)",
                                style: { fontSize: 18 }
                              }
                            ),
                            attributes.status === "received" && /* @__PURE__ */ jsx(
                              MdDoneAll,
                              {
                                color: "var(--rce-color-green)",
                                style: { fontSize: 18 }
                              }
                            ),
                            attributes.status === "read" && /* @__PURE__ */ jsx(
                              MdDoneAll,
                              {
                                color: "var(--rce-color-light-blue)",
                                style: { fontSize: 18 }
                              }
                            )
                          ] })
                        ]
                      }
                    )
                  ]
                }
              )
            ]
          }
        )
      ]
    }
  );
};
var MessageBox_default = MessageBox;

export {
  MessageBox_default
};
