import {
  MessageBox_default
} from "./chunk-CX5L3LQW.mjs";
import {
  Badge_default
} from "./chunk-IK3UXS7Y.mjs";
import {
  Button_default
} from "./chunk-63HD37UK.mjs";
import {
  __objRest,
  __spreadProps,
  __spreadValues
} from "./chunk-YUVL7GHC.mjs";

// src/MessageList/MessageList.tsx
import {
  useEffect,
  useRef,
  useState
} from "react";
import classNames from "classnames";
import { MdKeyboardArrowDown } from "react-icons/md";
import { jsx, jsxs } from "react/jsx-runtime";
import { createElement } from "react";
var MessageList = (_a) => {
  var _b = _a, {
    reference,
    lockable = false,
    toBottomHeight = 300,
    downButton = null
  } = _b, props = __objRest(_b, [
    "reference",
    "lockable",
    "toBottomHeight",
    "downButton"
  ]);
  var _a2;
  const [scrollBottom, setScrollBottom] = useState(0);
  const [scrollButton, setScrollButton] = useState(false);
  const prevProps = useRef(props);
  const checkScroll = () => {
    const e = reference;
    if (!e || !e.current) return;
    if (toBottomHeight === "100%" || toBottomHeight && scrollBottom < Number(toBottomHeight)) {
      e.current.scrollTop = e.current.scrollHeight;
    } else {
      if (lockable) {
        e.current.scrollTop = e.current.scrollHeight - e.current.offsetHeight - scrollBottom;
      }
    }
  };
  useEffect(() => {
    var _a3;
    if (!(reference == null ? void 0 : reference.current)) return;
    if (((_a3 = prevProps.current) == null ? void 0 : _a3.dataSource.length) !== props.dataSource.length) {
      setScrollBottom(getBottom(reference.current));
      checkScroll();
    }
    prevProps.current = props;
  }, [checkScroll, reference, props]);
  const getBottom = (e) => {
    if (e) {
      return e.scrollHeight - e.scrollTop - e.offsetHeight;
    }
    return 0;
  };
  const onScroll = (e) => {
    const element = e == null ? void 0 : e.currentTarget;
    const bottom = getBottom(element);
    setScrollBottom(bottom);
    if (toBottomHeight === "100%" || toBottomHeight && bottom > Number(toBottomHeight)) {
      if (!scrollButton) {
        setScrollButton(true);
        setScrollBottom(bottom);
      }
    } else {
      if (scrollButton) {
        setScrollButton(false);
        setScrollBottom(bottom);
      }
    }
    if (props.onScroll instanceof Function) {
      props.onScroll(e);
    }
  };
  const toBottom = (e) => {
    if (!(reference == null ? void 0 : reference.current)) return;
    const el = reference.current;
    el.scrollTop = el.scrollHeight;
    if (props.onDownButtonClick instanceof Function) props.onDownButtonClick(e);
  };
  return /* @__PURE__ */ jsxs(
    "div",
    __spreadProps(__spreadValues({}, props.customProps), {
      className: classNames(["rce-container-mlist", props.className]),
      children: [
        !!props.children && props.isShowChild && props.children,
        /* @__PURE__ */ jsx(
          "div",
          {
            ref: reference,
            onScroll: (e) => onScroll(e),
            className: "rce-mlist",
            children: (_a2 = props.dataSource) == null ? void 0 : _a2.map((x, i) => /* @__PURE__ */ createElement(MessageBox_default, __spreadProps(__spreadValues(__spreadValues({}, x), props), { key: `message-${i.toString()}` })))
          }
        ),
        scrollButton && toBottomHeight !== "100%" && /* @__PURE__ */ jsx(
          Button_default,
          {
            circle: true,
            className: "rce-mlist-down-button",
            onClick: (e) => toBottom(e),
            color: "var(--rce-color-gray)",
            backgroundColor: "var(--rce-color-white)",
            icon: { component: /* @__PURE__ */ jsx(MdKeyboardArrowDown, { size: 40 }) },
            style: { padding: 2 },
            children: (props == null ? void 0 : props.downButtonBadge) ? /* @__PURE__ */ jsx(
              Badge_default,
              {
                className: "rce-mlist-down-button--badge",
                value: props == null ? void 0 : props.downButtonBadge
              }
            ) : void 0
          }
        )
      ]
    })
  );
};
var MessageList_default = MessageList;

export {
  MessageList_default
};
